#!/usr/bin/env python3

import sys

with open(sys.argv[1], 'rb') as fh:
    pos = 0
    while True:
        b = fh.read(1)
        num = ord(b)
        as_str = b.decode("utf8") if 32 <= num <= 127 else '\u00b7'
        as_bin = bin(num)[2:].zfill(8)
        as_hex = hex(num)[2:].zfill(2)
        print("{:07d}   {:3d}   {}   {}   {} {}".format(
            pos, num, as_str, as_hex, as_bin[:4], as_bin[4:]))
        pos += 1
